
package de.ivu.elect.presentation.protokollierung;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.WahlOderWahlterminApp;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollSearchParameters;
import de.ivu.elect.business.protokollierung.entity.LoeschProtokoll;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@Named(AbstractLoeschProtokollSearchView.COMPONENT_NAME)
public class LoeschProtokollSearchView extends AbstractLoeschProtokollSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlOderWahlterminApp wahlOderWahlterminApp;

  @Nullable
  @PreConditionCheck
  public String checkPreCondition() {

    if (wahlOderWahlterminApp.isWahlterminApp() && !isWahlterminSelected()) {
      return getStartViewId();
    }

    if (wahlOderWahlterminApp.isWahlApp() && !isWahlSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  public LoeschProtokollSearchParameters getSearchParameters() {
    LoeschProtokollSearchParameters searchParameters = super.getSearchParameters();
    searchParameters.getLoeschProtokoll().setWahltermin(getSelectedWahltermin());
    searchParameters.getLoeschProtokoll().setWahl(getSelectedWahl());
    return searchParameters;
  }

  @Override
  protected AbstractGebietSecurityFilter<LoeschProtokoll> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  @Override
  protected void presetSearchParameters() {
// nichts zu tun
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
//    LoeschProtokoll loeschProtokoll = getSearchParameters().getLoeschProtokoll();
//    LoeschProtokollProperties properties = loeschProtokoll.getProperties();

    addLimitProperty(formBuilder);
  }

}
